unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Titre: TEdit;
    Objet: TEdit;
    Auteur: TEdit;
    Categorie: TEdit;
    MotsCles: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Lire: TButton;
    Modifier: TButton;
    NomFichier: TEdit;
    Label6: TLabel;
    Commentaires: TMemo;
    Label7: TLabel;
    Bevel1: TBevel;
    Label8: TLabel;
    Memo1: TMemo;
    Label9: TLabel;
    procedure LireClick(Sender: TObject);
    procedure ModifierClick(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation
uses Storage;
{$R *.dfm}

procedure TForm1.LireClick(Sender: TObject);
var FileName: string;
begin
     FileName:=NomFichier.Text;

     if (ExtractFileName(FileName)=FileName) and (ExtractFilePath(FileName)<>ExtractFilePath(ParamStr(0))) then
        FileName:=ExtractFilePath(ParamStr(0))+ExtractFileName(FileName);

     if FileExists(FileName) then
     begin
          // Cet exemple ne fait que modifier, sur tout type de fichier, les informations de la NTFS
          // (qui ne sont pas  confondre avec les Mtadonnes stockes sur les fichiers multimdias (<<voir Mtadonnes.zip>>) ).
          // En faisant "Clic droit > Proprits > Rsum" sur un fichier multimdia, ce sont
          // les Mtadonnes qui s'affichent (=celles contenues dans le fichier), et les donnes de
          // la NTFS n'apparaissent pas, mme si elles existent.
          // En faisant "Clic droit > Proprits > Rsum" sur un fichier NON multimdia, ce sont
          // les donnes de la NTFS qui s'affichent.

          // En cas d'archivage du fichier (dans un ZIP par exemple), les donnes NTFS ne sont pas crites
          // dans l'archive compresse, contrairement aux Mtadonnes.
          Titre.Text       :=GetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_TITLE);
          Objet.Text       :=GetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_SUBJECT);
          Auteur.Text      :=GetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_AUTHOR);
          Categorie.Text   :=GetFileSummaryInfo(FileName, FMTID_DocSummaryInformation, PIDDSI_CATEGORY);
          MotsCles.Text    :=GetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_KEYWORDS);
          Commentaires.Text:=GetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_COMMENTS);
          
          if (Titre.Text='') and (Objet.Text='') and (Auteur.Text='') and (Categorie.Text='') and (MotsCles.Text='') and (Commentaires.Text='') then
              MessageBox(Handle, 'Aucune donne de rsum dans ce fichier.','Information',0);
     end;
end;

procedure TForm1.ModifierClick(Sender: TObject);
var FileName: string;
begin
     FileName:=NomFichier.Text;

     if (ExtractFileName(FileName)=FileName) and (ExtractFilePath(FileName)<>ExtractFilePath(ParamStr(0))) then
        FileName:=ExtractFilePath(ParamStr(0))+ExtractFileName(FileName);

     if FileExists(FileName) then
          if not isNTFS(FileName) then ShowMessage('Partition incompatible.')
          else
          begin
               // Ecritures des informations dans la NTFS
               SetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_TITLE, Titre.Text);
               SetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_SUBJECT, Objet.Text);
               SetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_AUTHOR, Auteur.Text);
               SetFileSummaryInfo(FileName, FMTID_DocSummaryInformation, PIDDSI_CATEGORY, Categorie.Text);
               SetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_KEYWORDS, MotsCles.Text);
               SetFileSummaryInfo(FileName, FMTID_SummaryInformation, PIDSI_COMMENTS, Commentaires.Text);
          end;
end;

end.
